/*
 * HistoEAEDetectorElement.h
 *
 *  Created on: Mar 30, 2016
 *      Author: acq
 */

#ifndef ETOTDETECTORELEMENT_H_
#define ETOTDETECTORELEMENT_H_


#include "controllers/common/acquisition/detector/DetectorElement.h"
#include "drivers/ioxos/mpda_dpp/MpdaDPPDriver.h"

namespace npp {

/*!
 * \class EDEDetectorElement
 * \brief EDEDetectorElement class
 *
 * \par
 *	This class overload. DetectorElement class. It creates a new data array for plot window.
 *	The data have to be rotated for the plot.
 */
class ETotDetectorElement: public acquisition::DetectorElement {

public:

	//! Type of controller
	static const std::string TYPE;

	/*!
	 * \brief Constructor
	 * \param[in] name the name of the experiment controller
	 */
	ETotDetectorElement(const std::string& name);

	/*!
	 * \brief Destructor
	 */
	virtual ~ETotDetectorElement();

	/*!
	 * \brief Method called before changing the property value
	 *
	 * This method is called after setting configuration during the creation of controller.
	 */
	virtual void postConfiguration();

private:

	DriverPtr<mpda_dpp::MpdaDPPDriver> m_Driver; //! Pointer on histo data

	void updateData();

};

}
#endif



