/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef NPP_LISTMODEBLOCK_H
#define NPP_LISTMODEBLOCK_H

#include <iostream>
#include <vector>
#include <string>
#include "controllers/common/datafile/DataBlock.h"

class AbstractController;

namespace npp {

class ListModeBlock: public DataBlock {

public:
	ListModeBlock(uint32 nbdetectors, const vector<AbstractController*>& detectorControllers);
	virtual ~ListModeBlock();

	void writeBlock(std::ofstream & file);

private:
	uint32 m_NbDetectors;
	std::vector<AbstractController*> m_DetectorControllers;
	uint32 m_Oldlistmodedatasize;
};

}

#endif
