/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#include <stdlib.h>

#include "PerfectDfk31Au03Driver.h"
#include "Dfk31Au03Driver.h"
#include "Dfk31Au03Def.h"
#include "png++/png.hpp"

namespace dfk41au03 {

/*
 * Constructor
 */
PerfectDfk31Au03Driver::PerfectDfk31Au03Driver(Dfk31Au03Driver* owner) :
		Dfk31Au03State(owner) {
	/* Empty */
}

/*
 * Destructor
 */
PerfectDfk31Au03Driver::~PerfectDfk31Au03Driver() {
	/* Empty */
}

void PerfectDfk31Au03Driver::init() {
}

/*
 * clearvme/daugther/Dfk31Au03
 */
void PerfectDfk31Au03Driver::clear() {
	// Read command

}

/*
 * writeParam
 */
void PerfectDfk31Au03Driver::writeParam() {
}

/*
 * synchroniseRead
 */
void PerfectDfk31Au03Driver::synchroniseRead() {
	read();
	owner()->m_SynchroniseReadTerminated = true;
}

/*
 * read
 */
void PerfectDfk31Au03Driver::read() {
//	// Read command
//	streampos size;
//	ifstream file("/users/locatelli/camera.png", ios::in | ios::binary | ios::ate);
//	int32 arraySize = 0;
//	if (file.is_open()) {
//		size = file.tellg();
//		if (owner()->m_pngarray == NULL) {
//			arraySize = size / 4;
//			if (arraySize * 4 < size) {
//				arraySize++;
//			}
//			owner()->m_pngarray = new int32[arraySize];
//		}
//		char * memblock = reinterpret_cast<char *>(owner()->m_pngarray);
//		file.seekg(0, ios::beg);
//		file.read(memblock, size);
//		file.close();
//	}
//	owner()->height = YSIZE;
//	owner()->width = XSIZE;
//	owner()->bitPerPixel = RGB24BIT;
//	owner()->pixelFormat = PNG;
//	owner()->PNGData.update(owner()->m_pngarray);
//	owner()->PNGData.setSize(arraySize);
//	owner()->PNGData.sendEvent();
	int32 j = 0;
	int32 y;
	uint8 dest[XSIZE * YSIZE * 3];
	for (y = 0; y < XSIZE * YSIZE * 2 - 4; y = y + 4) {

		int32 u = y + 1;

		int32 v = y + 3;
		//            printf("src[3] %d\n",src[3]);

		int32 u1 = (((u - 128) << 7) + (u - 128)) >> 6;
		int32 rg = (((u - 128) << 1) + (u - 128) + ((v - 128) << 2) + ((v - 128) << 1)) >> 3;
		int32 v1 = (((v - 128) << 1) + (v - 128)) >> 1;

		dest[j + 0] = y + 0 + v1;
		dest[j + 1] = y + 0 - rg;
		dest[j + 2] = y + 0 + u1;

		dest[j + 3] = y + 0 + v1;
		dest[j + 4] = y + 2 + v1;
		dest[j + 5] = y + 2 - rg;
		j = j + 6;

		// printf("convert size : %d\n",j);
		// src += 4;

		//  src += stride - (width * 2);
	}
	owner()->height = YSIZE;
	owner()->width = XSIZE;
	owner()->bitPerPixel = RGB24BIT;
	owner()->pixelFormat = PNG;

	std::string localstring(reinterpret_cast<const char *>(dest), XSIZE * YSIZE * 3);
	owner()->RGBData = localstring;

	uint32 p = 0;
	png::image<png::rgb_pixel> img(XSIZE, YSIZE);
	for (png::uint_32 y = 0; y < img.get_height(); ++y) {
	    for (png::uint_32 x = 0; x < img.get_width(); ++x) {
	    	img[y][x] = png::rgb_pixel(dest[p], dest[p + 1], dest[p + 2]);
	    	p += 3;
	    }
	}
	ostringstream dec;
	img.write_stream(dec);
	int32 arraySize = dec.str().size() / 4;
	if (arraySize * 4 < dec.str().size()) {
		arraySize++;
	}
	delete [] owner()->m_pngarray;
	owner()->m_pngarray = new int32[arraySize];
	memcpy(owner()->m_pngarray, dec.str().c_str(), dec.str().size());
	owner()->PNGData.update(owner()->m_pngarray);
	owner()->PNGData.setSize(arraySize);
	owner()->PNGData.sendEvent();

}

/*
 * pause 
 */
void PerfectDfk31Au03Driver::pause() {
}

/*
 * continue 
 */
void PerfectDfk31Au03Driver::resume() {
}

/*
 * start
 */
void PerfectDfk31Au03Driver::start() {
}

/*
 * stop
 */
void PerfectDfk31Au03Driver::stop() {
}

/*
 * readStatus
 */
void PerfectDfk31Au03Driver::readStatus() {
	owner()->startActivated = false;
	// Status command
	owner()->computeAcquisitionStatus(0);
	owner()->computeDetectorStatus(0);
	if (owner()->m_SynchroniseReadActivated == true) {
		if (owner()->m_SynchroniseReadTerminated == true) {
			owner()->m_SynchroniseReadActivated = false;
			owner()->m_SynchroniseReadTerminated = false;
			owner()->commandProgression = PROGRESSION_END_DEVICE_CONTAINER;
		}
	} else {
		owner()->commandProgression = PROGRESSION_END_DEVICE_CONTAINER;
	}
}

/*
 * readInfos
 */
void PerfectDfk31Au03Driver::readInfos() {
}

}
